/*
 * Copyright (c) 2008, Marcus von Appen
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "papi_msaa.h"

void
constants_export (PyObject *module)
{
    /* Navigation constants. */
    PyModule_AddIntConstant (module, "NAVDIR_DOWN", NAVDIR_DOWN);
    PyModule_AddIntConstant (module, "NAVDIR_FIRSTCHILD", NAVDIR_FIRSTCHILD);
    PyModule_AddIntConstant (module, "NAVDIR_LASTCHILD", NAVDIR_LASTCHILD);
    PyModule_AddIntConstant (module, "NAVDIR_LEFT", NAVDIR_LEFT);
    PyModule_AddIntConstant (module, "NAVDIR_NEXT", NAVDIR_NEXT);
    PyModule_AddIntConstant (module, "NAVDIR_PREVIOUS", NAVDIR_PREVIOUS);
    PyModule_AddIntConstant (module, "NAVDIR_RIGHT", NAVDIR_RIGHT);
    PyModule_AddIntConstant (module, "NAVDIR_UP", NAVDIR_UP);

    PyModule_AddIntConstant (module, "SELFLAG_NONE", SELFLAG_NONE);
    PyModule_AddIntConstant (module, "SELFLAG_TAKEFOCUS", SELFLAG_TAKEFOCUS);
    PyModule_AddIntConstant (module, "SELFLAG_TAKESELECTION",
        SELFLAG_TAKESELECTION);
    PyModule_AddIntConstant (module, "SELFLAG_EXTENDSELECTION",
        SELFLAG_EXTENDSELECTION);
    PyModule_AddIntConstant (module, "SELFLAG_ADDSELECTION",
        SELFLAG_ADDSELECTION);
    PyModule_AddIntConstant (module, "SELFLAG_REMOVESELECTION",
        SELFLAG_REMOVESELECTION);
    
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_ALERT", ROLE_SYSTEM_ALERT);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_ANIMATION",
        ROLE_SYSTEM_ANIMATION);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_APPLICATION",
        ROLE_SYSTEM_APPLICATION);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_BORDER", ROLE_SYSTEM_BORDER);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_BUTTONDROPDOWN",
        ROLE_SYSTEM_BUTTONDROPDOWN);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_BUTTONDROPDOWNGRID",
        ROLE_SYSTEM_BUTTONDROPDOWNGRID);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_BUTTONMENU",
        ROLE_SYSTEM_BUTTONMENU);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_CARET", ROLE_SYSTEM_CARET);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_CELL", ROLE_SYSTEM_CELL);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_CHARACTER",
        ROLE_SYSTEM_CHARACTER);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_CHART", ROLE_SYSTEM_CHART);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_CHECKBUTTON",
        ROLE_SYSTEM_CHECKBUTTON);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_CLIENT", ROLE_SYSTEM_CLIENT);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_CLOCK", ROLE_SYSTEM_CLOCK);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_COLUMN", ROLE_SYSTEM_COLUMN);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_COLUMNHEADER",
        ROLE_SYSTEM_COLUMNHEADER);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_COMBOBOX",
        ROLE_SYSTEM_COMBOBOX);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_CURSOR", ROLE_SYSTEM_CURSOR);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_DIAGRAM",
        ROLE_SYSTEM_DIAGRAM);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_DIAL", ROLE_SYSTEM_DIAL);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_DIALOG", ROLE_SYSTEM_DIALOG);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_DOCUMENT",
        ROLE_SYSTEM_DOCUMENT);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_DROPLIST",
        ROLE_SYSTEM_DROPLIST);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_EQUATION",
        ROLE_SYSTEM_EQUATION);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_GRAPHIC",
        ROLE_SYSTEM_GRAPHIC);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_GRIP", ROLE_SYSTEM_GRIP);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_GROUPING",
        ROLE_SYSTEM_GROUPING);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_HELPBALLOON",
        ROLE_SYSTEM_HELPBALLOON);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_HOTKEYFIELD",
        ROLE_SYSTEM_HOTKEYFIELD);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_INDICATOR",
        ROLE_SYSTEM_INDICATOR);
#ifdef ROLE_SYSTEM_IPADDRESS
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_IPADDRESS",
        ROLE_SYSTEM_IPADDRESS);
#endif
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_LINK", ROLE_SYSTEM_LINK);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_LIST", ROLE_SYSTEM_LIST);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_LISTITEM",
        ROLE_SYSTEM_LISTITEM);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_MENUBAR",
        ROLE_SYSTEM_MENUBAR);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_MENUITEM",
        ROLE_SYSTEM_MENUITEM);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_MENUPOPUP",
        ROLE_SYSTEM_MENUPOPUP);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_OUTLINE",
        ROLE_SYSTEM_OUTLINE);
#ifdef ROLE_SYSTEM_OUTLINEBUTTON
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_OUTLINEBUTTON",
        ROLE_SYSTEM_OUTLINEBUTTON);
#endif
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_OUTLINEITEM",
        ROLE_SYSTEM_OUTLINEITEM);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_PAGETAB",
        ROLE_SYSTEM_PAGETAB);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_PAGETABLIST",
        ROLE_SYSTEM_PAGETABLIST);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_PANE", ROLE_SYSTEM_PANE);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_PROGRESSBAR",
        ROLE_SYSTEM_PROGRESSBAR);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_PROPERTYPAGE",
        ROLE_SYSTEM_PROPERTYPAGE);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_PUSHBUTTON",
        ROLE_SYSTEM_PUSHBUTTON);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_RADIOBUTTON",
        ROLE_SYSTEM_RADIOBUTTON);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_ROW", ROLE_SYSTEM_ROW);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_ROWHEADER",
        ROLE_SYSTEM_ROWHEADER);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_SCROLLBAR",
        ROLE_SYSTEM_SCROLLBAR);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_SEPARATOR",
        ROLE_SYSTEM_SEPARATOR);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_SLIDER", ROLE_SYSTEM_SLIDER);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_SOUND", ROLE_SYSTEM_SOUND);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_SPINBUTTON",
        ROLE_SYSTEM_SPINBUTTON);
#ifdef ROLE_SYSTEM_SPLITBUTTON
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_SPLITBUTTON",
        ROLE_SYSTEM_SPLITBUTTON);
#endif
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_STATICTEXT",
        ROLE_SYSTEM_STATICTEXT);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_STATUSBAR",
        ROLE_SYSTEM_STATUSBAR);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_TABLE", ROLE_SYSTEM_TABLE);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_TEXT", ROLE_SYSTEM_TEXT);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_TITLEBAR",
        ROLE_SYSTEM_TITLEBAR);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_TOOLBAR",
        ROLE_SYSTEM_TOOLBAR);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_TOOLTIP",
        ROLE_SYSTEM_TOOLTIP);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_WHITESPACE",
        ROLE_SYSTEM_WHITESPACE);
    PyModule_AddIntConstant (module, "ROLE_SYSTEM_WINDOW", ROLE_SYSTEM_WINDOW);

    PyModule_AddIntConstant (module, "STATE_SYSTEM_ALERT_LOW",
        STATE_SYSTEM_ALERT_LOW);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_ANIMATED",
        STATE_SYSTEM_ANIMATED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_BUSY", STATE_SYSTEM_BUSY);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_CHECKED",
        STATE_SYSTEM_CHECKED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_COLLAPSED",
        STATE_SYSTEM_COLLAPSED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_DEFAULT",
        STATE_SYSTEM_DEFAULT);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_EXPANDED",
        STATE_SYSTEM_EXPANDED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_EXTSELECTABLE",
        STATE_SYSTEM_EXTSELECTABLE);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_FLOATING",
        STATE_SYSTEM_FLOATING);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_FOCUSABLE",
        STATE_SYSTEM_FOCUSABLE);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_FOCUSED",
        STATE_SYSTEM_FOCUSED);
#ifdef STATE_SYSTEM_HASPOPUP
    PyModule_AddIntConstant (module, "STATE_SYSTEM_HASPOPUP",
        STATE_SYSTEM_HASPOPUP);
#endif
    PyModule_AddIntConstant (module, "STATE_SYSTEM_HOTTRACKED",
        STATE_SYSTEM_HOTTRACKED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_INVISIBLE",
        STATE_SYSTEM_INVISIBLE);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_LINKED",
        STATE_SYSTEM_LINKED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_MARQUEED",
        STATE_SYSTEM_MARQUEED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_MIXED", STATE_SYSTEM_MIXED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_MOVEABLE",
        STATE_SYSTEM_MOVEABLE);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_MULTISELECTABLE",
        STATE_SYSTEM_MULTISELECTABLE);
#ifdef STATE_SYSTEM_NORMAL
    PyModule_AddIntConstant (module, "STATE_SYSTEM_NORMAL",
        STATE_SYSTEM_NORMAL);
#else
    PyModule_AddIntConstant (module, "STATE_SYSTEM_NORMAL", 0);
#endif
    PyModule_AddIntConstant (module, "STATE_SYSTEM_OFFSCREEN",
        STATE_SYSTEM_OFFSCREEN);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_PRESSED",
        STATE_SYSTEM_PRESSED);
#ifdef STATE_SYSTEM_PROTECTED
    PyModule_AddIntConstant (module, "STATE_SYSTEM_PROTECTED",
        STATE_SYSTEM_PROTECTED);
#endif
    PyModule_AddIntConstant (module, "STATE_SYSTEM_READONLY",
        STATE_SYSTEM_READONLY);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_SELECTABLE",
        STATE_SYSTEM_SELECTABLE);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_SELECTED",
        STATE_SYSTEM_SELECTED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_SELFVOICING",
        STATE_SYSTEM_SELFVOICING);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_SIZEABLE",
        STATE_SYSTEM_SIZEABLE);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_TRAVERSED",
        STATE_SYSTEM_TRAVERSED);
    PyModule_AddIntConstant (module, "STATE_SYSTEM_UNAVAILABLE",
        STATE_SYSTEM_UNAVAILABLE);
}
